workflow:
  rules:
    - if: $CI_COMMIT_BRANCH == "master"

stages:
  - deploy-cmj
  - deploy-wireguard

deploy-cmj:
  image:
    name: hashicorp/terraform:latest
    entrypoint: ["/bin/sh", "-c"]
  stage: deploy-cmj
  before_script:
    # Setup ssh
    - eval $(ssh-agent -s)
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    - echo "$SSH_PRIVATE_KEY" > ~/.ssh/id_rsa
    - chmod 600 ~/.ssh/id_rsa
    - ssh-add ~/.ssh/id_rsa
    - ssh-keygen -y -f ~/.ssh/id_rsa > ~/.ssh/id_rsa.pub
    # Setup helm
    - apk update && apk add curl bash openssl
    - curl -LO "https://storage.googleapis.com/kubernetes-release/release/$(curl -s https://storage.googleapis.com/kubernetes-release/release/stable.txt)/bin/linux/amd64/kubectl" 
    - chmod +x ./kubectl 
    - mv ./kubectl /usr/local/bin/kubectl 
    - curl -fsSL -o get_helm.sh https://raw.githubusercontent.com/helm/helm/master/scripts/get-helm-3 
    - chmod +x get_helm.sh && ./get_helm.sh
    # pushing charts is experimental
    - export HELM_EXPERIMENTAL_OCI=1
  script:
    # login to registry
    # - helm registry login -u ${CI_REGISTRY_USER} --password ${CI_REGISTRY_PASSWORD} https://registry.gitlab.com
    # pull charts
    # - helm pull ${CI_REGISTRY}/wikoion-dev-projects/deployments/go-reframe-blog-deploy/reframe-blog:latest
    # - helm chart export ${CI_REGISTRY}/wikoion-dev-projects/deployments/go-reframe-blog-deploy/reframe-blog:latest

    # - helm pull ${CI_REGISTRY}/wikoion-dev-projects/deployments/go-reframe-blog-deploy/golang-blog:latest
    # - helm chart export ${CI_REGISTRY}/wikoion-dev-projects/deployments/go-reframe-blog-deploy/golang-blog:latest

    # Terraform
    - sshtoken=$(ssh-keygen -E md5 -lf ~/.ssh/id_rsa.pub | awk '{print $2}')
    - export AWS_ACCESS_KEY_ID=${terraform_bucket_key}
    - export AWS_SECRET_ACCESS_KEY=${terraform_bucket_secret}
    - cd do-k8s-cmj
    - sed -i -e "s~<NEXTCLOUD_PRIMARY_BUCKET_KEY>~${nextcloud_primary_bucket_key}~g" modules/nextcloud/nextcloud-values-s3.yaml
    - sed -i -e "s~<NEXTCLOUD_PRIMARY_BUCKET_SECRET>~${nextcloud_primary_bucket_secret}~g" modules/nextcloud/nextcloud-values-s3.yaml
    - terraform init -upgrade
    - terraform validate
    - terraform apply -auto-approve -var "do_token=${do_token}" -var "pub_key=$HOME/.ssh/id_rsa.pub" -var "pvt_key=$HOME/.ssh/id_rsa" -var "ssh_fingerprint=$sshtoken" -var "gitlab_token=${gitlab_token}" -var "gitlab_runner_token=${gitlab_runner_token}" -var "CF_API_EMAIL=${CF_API_EMAIL}" -var "CF_API_KEY=${CF_API_KEY}" -var "grafana_user=${grafana_user}" -var "grafana_password=${grafana_password}" -var "nextcloud_username=${nextcloud_username}" -var "nextcloud_password=${nextcloud_password}" -var "nextcloud_external_bucket_key=${nextcloud_external_bucket_key}" -var "nextcloud_external_bucket_secret=${nextcloud_external_bucket_secret}" -var "nextcloud_mariadb_username=${nextcloud_mariadb_username}" -var "nextcloud_mariadb_password=${nextcloud_mariadb_password}" -var "mongo_username=${mongo_username}" -var "mongo_password=${mongo_password}" -var "mongo_root_password=${mongo_root_password}" -var "elastic_user=${elastic_user}" -var "elastic_password=${elastic_password}" -var "golang_api_key=${golang_api_key}" -var "vault_bucket_key=${vault_bucket_key}" -var "vault_bucket_secret=${vault_bucket_secret}"

deploy-wireguard:
  image:
    name: hashicorp/terraform:latest
    entrypoint: ["/bin/sh", "-c"]
  stage: deploy-wireguard
  script:
    - export AWS_ACCESS_KEY_ID=${terraform_bucket_key}
    - export AWS_SECRET_ACCESS_KEY=${terraform_bucket_secret}
    - cd wireguard
    - ssh-keygen -f wg_id_rsa -t rsa -N ''
    - terraform init -upgrade
    - terraform validate
    - terraform apply -auto-approve -var "do_token=${do_token}" -var "pub_key=wg_id_rsa.pub" -var "pvt_key=wg_id_rsa" -var "CF_API_EMAIL=${CF_API_EMAIL}" -var "CF_API_KEY=${CF_API_KEY}" -var "wg_admin_user=${wg_admin_user}" -var "wg_admin_password=${wg_admin_password}" -var "wg_wireguard_private_key=${wg_wireguard_private_key}"
